Index: issm/trunk/src/c/classes/Inputs/TriaInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/TriaInput.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/TriaInput.cpp	(revision 18301)
@@ -13,28 +13,27 @@
 
 /*TriaInput constructors and destructor*/
-/*FUNCTION TriaInput::TriaInput(){{{*/
-TriaInput::TriaInput(){
+TriaInput::TriaInput(){/*{{{*/
 	values = NULL;
 }
 /*}}}*/
-/*FUNCTION TriaInput::TriaInput(int in_enum_type,IssmDouble* invalues,element_type_in){{{*/
-TriaInput::TriaInput(int in_enum_type,IssmDouble* in_values,int element_type_in)
-	:TriaRef(1)
-{
-
-	/*Set TriaRef*/
-	this->SetElementType(element_type_in,0);
-	this->element_type=element_type_in;
+TriaInput::TriaInput(int in_enum_type,IssmDouble* in_values,int interpolation_type_in){/*{{{*/
 
 	/*Set Enum*/
-	enum_type=in_enum_type;
+	this->enum_type=in_enum_type;
+	this->interpolation_type=interpolation_type_in;
+
+	int numnodes = this->NumberofNodes(this->interpolation_type);
 
 	/*Set values*/
-	this->values=xNew<IssmDouble>(this->NumberofNodes());
-	for(int i=0;i<this->NumberofNodes();i++) values[i]=in_values[i];
-}
-/*}}}*/
-/*FUNCTION TriaInput::~TriaInput(){{{*/
-TriaInput::~TriaInput(){
+	if (numnodes > 0){
+		this->values=xNew<IssmDouble>((unsigned int)numnodes);
+		for(int i=0;i<this->NumberofNodes(this->interpolation_type);i++) values[i]=in_values[i];
+	}
+	else{
+		this->values = NULL;
+	}
+}
+/*}}}*/
+TriaInput::~TriaInput(){/*{{{*/
 	xDelete<IssmDouble>(this->values);
 }
@@ -42,22 +41,18 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION TriaInput::Echo {{{*/
-void TriaInput::Echo(void){
+void TriaInput::Echo(void){/*{{{*/
 	this->DeepEcho();
 }
 /*}}}*/
-/*FUNCTION TriaInput::DeepEcho{{{*/
-void TriaInput::DeepEcho(void){
+void TriaInput::DeepEcho(void){/*{{{*/
 
 	_printf_(setw(15)<<"   TriaInput "<<setw(25)<<left<<EnumToStringx(this->enum_type)<<" [");
-	for(int i=0;i<this->NumberofNodes();i++) _printf_(" "<<this->values[i]);
-	_printf_("] ("<<EnumToStringx(this->element_type)<<")\n");
-}
-/*}}}*/
-/*FUNCTION TriaInput::Id{{{*/
-int    TriaInput::Id(void){ return -1; }
-/*}}}*/
-/*FUNCTION TriaInput::ObjectEnum{{{*/
-int TriaInput::ObjectEnum(void){
+	for(int i=0;i<this->NumberofNodes(this->interpolation_type);i++) _printf_(" "<<this->values[i]);
+	_printf_("] ("<<EnumToStringx(this->interpolation_type)<<")\n");
+}
+/*}}}*/
+int  TriaInput::Id(void){ return -1; }/*{{{*/
+/*}}}*/
+int  TriaInput::ObjectEnum(void){/*{{{*/
 
 	return TriaInputEnum;
@@ -65,8 +60,7 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::copy{{{*/
-Object* TriaInput::copy() {
-
-	return new TriaInput(this->enum_type,this->values,this->element_type);
+Object* TriaInput::copy() {/*{{{*/
+
+	return new TriaInput(this->enum_type,this->values,this->interpolation_type);
 
 }
@@ -74,6 +68,5 @@
 
 /*TriaInput management*/
-/*FUNCTION TriaInput::InstanceEnum{{{*/
-int TriaInput::InstanceEnum(void){
+int TriaInput::InstanceEnum(void){/*{{{*/
 
 	return this->enum_type;
@@ -81,6 +74,5 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::SpawnTriaInput{{{*/
-Input* TriaInput::SpawnTriaInput(int index1,int index2,int index3){
+Input* TriaInput::SpawnTriaInput(int index1,int index2,int index3){/*{{{*/
 
 	/*output*/
@@ -88,5 +80,5 @@
 
 	/*Create new Tria input (copy of current input)*/
-	outinput=new TriaInput(this->enum_type,&this->values[0],this->element_type);
+	outinput=new TriaInput(this->enum_type,&this->values[0],this->interpolation_type);
 
 	/*Assign output*/
@@ -95,11 +87,10 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::SpawnSegInput{{{*/
-Input* TriaInput::SpawnSegInput(int index1,int index2){
+Input* TriaInput::SpawnSegInput(int index1,int index2){/*{{{*/
 
 	/*output*/
 	SegInput* outinput=NULL;
 
-	if(this->element_type==P0Enum){ 
+	if(this->interpolation_type==P0Enum){ 
 		outinput=new SegInput(this->enum_type,&this->values[0],P0Enum);
 	}
@@ -121,22 +112,22 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::GetResultInterpolation{{{*/
-int  TriaInput::GetResultInterpolation(void){
-
+int  TriaInput::GetResultInterpolation(void){/*{{{*/
+
+	if(this->interpolation_type==P0Enum){
+		return P0Enum;
+	}
 	return P1Enum;
 
 }
 /*}}}*/
-/*FUNCTION TriaInput::GetResultNumberOfNodes{{{*/
-int  TriaInput::GetResultNumberOfNodes(void){
-
-	return this->NumberofNodes();
-
-}
-/*}}}*/
-/*FUNCTION TriaInput::ResultToPatch{{{*/
-void TriaInput::ResultToPatch(IssmDouble* values,int nodesperelement,int sid){
-
-	int numnodes = this->NumberofNodes();
+int  TriaInput::GetResultNumberOfNodes(void){/*{{{*/
+
+	return this->NumberofNodes(this->interpolation_type);
+
+}
+/*}}}*/
+void TriaInput::ResultToPatch(IssmDouble* values,int nodesperelement,int sid){/*{{{*/
+
+	int numnodes = this->NumberofNodes(this->interpolation_type);
 
 	/*Some checks*/
@@ -150,30 +141,26 @@
 
 /*Object functions*/
-/*FUNCTION TriaInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){{{*/
-void TriaInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){
+void TriaInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){/*{{{*/
 
 	/*Call TriaRef function*/
 	_assert_(gauss->Enum()==GaussTriaEnum);
-	TriaRef::GetInputValue(pvalue,&values[0],(GaussTria*)gauss);
-
-}
-/*}}}*/
-/*FUNCTION TriaInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list, Gauss* gauss){{{*/
-void TriaInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list, Gauss* gauss){
+	TriaRef::GetInputValue(pvalue,&values[0],(GaussTria*)gauss,this->interpolation_type);
+
+}
+/*}}}*/
+void TriaInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list, Gauss* gauss){/*{{{*/
 
 	/*Call TriaRef function*/
 	_assert_(gauss->Enum()==GaussTriaEnum);
-	TriaRef::GetInputDerivativeValue(p,&values[0],xyz_list,(GaussTria*)gauss);
-}
-/*}}}*/
-/*FUNCTION TriaInput::ChangeEnum{{{*/
-void TriaInput::ChangeEnum(int newenumtype){
+	TriaRef::GetInputDerivativeValue(p,&values[0],xyz_list,(GaussTria*)gauss,this->interpolation_type);
+}
+/*}}}*/
+void TriaInput::ChangeEnum(int newenumtype){/*{{{*/
 	this->enum_type=newenumtype;
 }
 /*}}}*/
-/*FUNCTION TriaInput::GetInputAverage{{{*/
-void TriaInput::GetInputAverage(IssmDouble* pvalue){
-
-	int        numnodes  = this->NumberofNodes();
+void TriaInput::GetInputAverage(IssmDouble* pvalue){/*{{{*/
+
+	int        numnodes  = this->NumberofNodes(this->interpolation_type);
 	IssmDouble numnodesd = reCast<int,IssmDouble>(numnodes);
 	IssmDouble value     = 0.;
@@ -185,6 +172,5 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::GetInputAllTimeAverages{{{*/
-void TriaInput::GetInputAllTimeAverages(IssmDouble** pvalues,IssmDouble** ptimes, int* pnumtimes){
+void TriaInput::GetInputAllTimeAverages(IssmDouble** pvalues,IssmDouble** ptimes, int* pnumtimes){/*{{{*/
 
 	IssmDouble* outvalues=NULL;
@@ -205,6 +191,5 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::GetInputUpToCurrentTimeAverages{{{*/
-void TriaInput::GetInputUpToCurrentTimeAverages(IssmDouble** pvalues, IssmDouble** ptimes, int* pnumtimes, IssmDouble currenttime){
+void TriaInput::GetInputUpToCurrentTimeAverages(IssmDouble** pvalues, IssmDouble** ptimes, int* pnumtimes, IssmDouble currenttime){/*{{{*/
 
 	IssmDouble* outvalues=NULL;
@@ -227,8 +212,7 @@
 
 /*Intermediary*/
-/*FUNCTION TriaInput::SquareMin{{{*/
-void TriaInput::SquareMin(IssmDouble* psquaremin,Parameters* parameters){
-
-	int        numnodes=this->NumberofNodes();
+void TriaInput::SquareMin(IssmDouble* psquaremin,Parameters* parameters){/*{{{*/
+
+	int        numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble squaremin;
 
@@ -242,17 +226,15 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::ContrainMin{{{*/
-void TriaInput::ConstrainMin(IssmDouble minimum){
-
-	int numnodes = this->NumberofNodes();
+void TriaInput::ConstrainMin(IssmDouble minimum){/*{{{*/
+
+	int numnodes = this->NumberofNodes(this->interpolation_type);
 	for(int i=0;i<numnodes;i++) if (values[i]<minimum) values[i]=minimum;
 }
 /*}}}*/
-/*FUNCTION TriaInput::InfinityNorm{{{*/
-IssmDouble TriaInput::InfinityNorm(void){
+IssmDouble TriaInput::InfinityNorm(void){/*{{{*/
 
 	/*Output*/
 	IssmDouble norm=0.;
-	int numnodes=this->NumberofNodes();
+	int numnodes=this->NumberofNodes(this->interpolation_type);
 
 	for(int i=0;i<numnodes;i++) if(fabs(values[i])>norm) norm=fabs(values[i]);
@@ -260,8 +242,7 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::Max{{{*/
-IssmDouble TriaInput::Max(void){
-
-	int  numnodes=this->NumberofNodes();
+IssmDouble TriaInput::Max(void){/*{{{*/
+
+	int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble max=values[0];
 
@@ -272,8 +253,7 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::MaxAbs{{{*/
-IssmDouble TriaInput::MaxAbs(void){
-
-	int  numnodes=this->NumberofNodes();
+IssmDouble TriaInput::MaxAbs(void){/*{{{*/
+
+	int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble max=fabs(values[0]);
 
@@ -284,8 +264,7 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::Min{{{*/
-IssmDouble TriaInput::Min(void){
-
-	const int  numnodes=this->NumberofNodes();
+IssmDouble TriaInput::Min(void){/*{{{*/
+
+	const int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble min=values[0];
 
@@ -296,8 +275,7 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::MinAbs{{{*/
-IssmDouble TriaInput::MinAbs(void){
-
-	const int  numnodes=this->NumberofNodes();
+IssmDouble TriaInput::MinAbs(void){/*{{{*/
+
+	const int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble min=fabs(values[0]);
 
@@ -308,22 +286,19 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::Scale{{{*/
-void TriaInput::Scale(IssmDouble scale_factor){
-
-	const int numnodes=this->NumberofNodes();
+void TriaInput::Scale(IssmDouble scale_factor){/*{{{*/
+
+	const int numnodes=this->NumberofNodes(this->interpolation_type);
 	for(int i=0;i<numnodes;i++)values[i]=values[i]*scale_factor;
 }
 /*}}}*/
-/*FUNCTION TriaInput::Set{{{*/
-void TriaInput::Set(IssmDouble setvalue){
-
-	const int numnodes=this->NumberofNodes();
+void TriaInput::Set(IssmDouble setvalue){/*{{{*/
+
+	const int numnodes=this->NumberofNodes(this->interpolation_type);
 	for(int i=0;i<numnodes;i++)values[i]=setvalue;
 }
 /*}}}*/
-/*FUNCTION TriaInput::AXPY{{{*/
-void TriaInput::AXPY(Input* xinput,IssmDouble scalar){
-
-	const int numnodes=this->NumberofNodes();
+void TriaInput::AXPY(Input* xinput,IssmDouble scalar){/*{{{*/
+
+	const int numnodes=this->NumberofNodes(this->interpolation_type);
 	TriaInput*  xtriainput=NULL;
 
@@ -331,5 +306,5 @@
 	if(xinput->ObjectEnum()!=TriaInputEnum) _error_("Operation not permitted because xinput is of type " << EnumToStringx(xinput->ObjectEnum()));
 	xtriainput=(TriaInput*)xinput;
-	if(xtriainput->element_type!=this->element_type) _error_("Operation not permitted because xinput is of type " << EnumToStringx(xinput->ObjectEnum()));
+	if(xtriainput->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because xinput is of type " << EnumToStringx(xinput->ObjectEnum()));
 
 	/*Carry out the AXPY operation depending on type:*/
@@ -338,9 +313,8 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::Constrain{{{*/
-void TriaInput::Constrain(IssmDouble cm_min, IssmDouble cm_max){
+void TriaInput::Constrain(IssmDouble cm_min, IssmDouble cm_max){/*{{{*/
 
 	int i;
-	const int numnodes=this->NumberofNodes();
+	const int numnodes=this->NumberofNodes(this->interpolation_type);
 
 	if(!xIsNan<IssmDouble>(cm_min)) for(i=0;i<numnodes;i++)if (this->values[i]<cm_min)this->values[i]=cm_min;
@@ -349,11 +323,9 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::GetVectorFromInputs{{{*/
-void TriaInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){
+void TriaInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){/*{{{*/
 	const int numvertices=3;
 	vector->SetValues(numvertices,doflist,this->values,INS_VAL);
 } /*}}}*/
-/*FUNCTION TriaInput::PointwiseMin{{{*/
-Input* TriaInput::PointwiseMin(Input* inputB){
+Input* TriaInput::PointwiseMin(Input* inputB){/*{{{*/
 
 	/*Ouput*/
@@ -363,5 +335,5 @@
 	int         i;
 	TriaInput  *xinputB   = NULL;
-	const int   numnodes  = this->NumberofNodes();
+	const int   numnodes  = this->NumberofNodes(this->interpolation_type);
 	IssmDouble *minvalues = xNew<IssmDouble>(numnodes);
 
@@ -369,5 +341,5 @@
 	if(inputB->ObjectEnum()!=TriaInputEnum)       _error_("Operation not permitted because inputB is of type " << EnumToStringx(inputB->ObjectEnum()));
 	xinputB=(TriaInput*)inputB;
-	if(xinputB->element_type!=this->element_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->element_type));
+	if(xinputB->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->interpolation_type));
 
 	/*Create point wise min*/
@@ -378,5 +350,5 @@
 
 	/*Create new Tria vertex input (copy of current input)*/
-	outinput=new TriaInput(this->enum_type,&minvalues[0],this->element_type);
+	outinput=new TriaInput(this->enum_type,&minvalues[0],this->interpolation_type);
 
 	/*Return output pointer*/
@@ -386,6 +358,5 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::PointwiseMax{{{*/
-Input* TriaInput::PointwiseMax(Input* inputB){
+Input* TriaInput::PointwiseMax(Input* inputB){/*{{{*/
 
 	/*Ouput*/
@@ -395,5 +366,5 @@
 	int         i;
 	TriaInput  *xinputB   = NULL;
-	const int   numnodes  = this->NumberofNodes();
+	const int   numnodes  = this->NumberofNodes(this->interpolation_type);
 	IssmDouble *maxvalues = xNew<IssmDouble>(numnodes);
 
@@ -401,5 +372,5 @@
 	if(inputB->ObjectEnum()!=TriaInputEnum) _error_("Operation not permitted because inputB is of type " << EnumToStringx(inputB->ObjectEnum()));
 	xinputB=(TriaInput*)inputB;
-	if(xinputB->element_type!=this->element_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->element_type));
+	if(xinputB->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->interpolation_type));
 
 	/*Create point wise max*/
@@ -410,5 +381,5 @@
 
 	/*Create new Tria vertex input (copy of current input)*/
-	outinput=new TriaInput(this->enum_type,&maxvalues[0],this->element_type);
+	outinput=new TriaInput(this->enum_type,&maxvalues[0],this->interpolation_type);
 
 	/*Return output pointer*/
@@ -418,6 +389,5 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::PointwiseDivide{{{*/
-Input* TriaInput::PointwiseDivide(Input* inputB){
+Input* TriaInput::PointwiseDivide(Input* inputB){/*{{{*/
 
 	/*Ouput*/
@@ -426,10 +396,10 @@
 	/*Intermediaries*/
 	TriaInput *xinputB  = NULL;
-	const int   numnodes = this->NumberofNodes();
+	const int   numnodes = this->NumberofNodes(this->interpolation_type);
 
 	/*Check that inputB is of the same type*/
 	if(inputB->ObjectEnum()!=TriaInputEnum)     _error_("Operation not permitted because inputB is of type " << EnumToStringx(inputB->ObjectEnum()));
 	xinputB=(TriaInput*)inputB;
-	if(xinputB->element_type!=this->element_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->element_type));
+	if(xinputB->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->interpolation_type));
 
 	/*Allocate intermediary*/
@@ -443,5 +413,5 @@
 
 	/*Create new Tria vertex input (copy of current input)*/
-	outinput=new TriaInput(this->enum_type,AdotBvalues,this->element_type);
+	outinput=new TriaInput(this->enum_type,AdotBvalues,this->interpolation_type);
 
 	/*Return output pointer*/
@@ -451,6 +421,5 @@
 }
 /*}}}*/
-/*FUNCTION TriaInput::Configure{{{*/
-void TriaInput::Configure(Parameters* parameters){
+void TriaInput::Configure(Parameters* parameters){/*{{{*/
 	/*do nothing: */
 }
Index: issm/trunk/src/c/classes/Inputs/TriaInput.h
===================================================================
--- issm/trunk/src/c/classes/Inputs/TriaInput.h	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/TriaInput.h	(revision 18301)
@@ -18,4 +18,5 @@
 	public:
 		int         enum_type;
+		int         interpolation_type;
 		IssmDouble* values;
 
Index: issm/trunk/src/c/classes/IoModel.cpp
===================================================================
--- issm/trunk/src/c/classes/IoModel.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/IoModel.cpp	(revision 18301)
@@ -19,6 +19,5 @@
 #include "../shared/shared.h"
 
-/*FUNCTION IoModel::IoModel(){{{*/
-IoModel::IoModel(){
+IoModel::IoModel(){/*{{{*/
 	this->fid=NULL;
 	this->data=NULL;
@@ -51,6 +50,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::IoModel(FILE*  iomodel_handle){{{*/
-IoModel::IoModel(FILE* iomodel_handle){
+IoModel::IoModel(FILE* iomodel_handle){/*{{{*/
 
 	/*First, keep track of the file handle: */
@@ -97,6 +95,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::~IoModel(){{{*/
-IoModel::~IoModel(){
+IoModel::~IoModel(){/*{{{*/
 
 	/*Delete independents*/
@@ -140,6 +137,5 @@
 /*}}}*/
 
-/*FUNCTION IoModel::CheckEnumSync{{{*/
-void  IoModel::CheckEnumSync(void){
+void  IoModel::CheckEnumSync(void){/*{{{*/
 
 	int record_enum,record_length;
@@ -226,6 +222,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::Constant(bool* poutput,int constant_enum){{{*/
-void IoModel::Constant(bool* poutput,int constant_enum){
+void IoModel::Constant(bool* poutput,int constant_enum){/*{{{*/
 
 	_assert_(constant_enum>=0);
@@ -235,6 +230,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::Constant(int* poutput,int constant_enum){{{*/
-void IoModel::Constant(int* poutput,int constant_enum){
+void IoModel::Constant(int* poutput,int constant_enum){/*{{{*/
 
 	_assert_(constant_enum>=0);
@@ -244,6 +238,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::Constant(IssmDouble* poutput,int constant_enum){{{*/
-void IoModel::Constant(IssmDouble* poutput,int constant_enum){
+void IoModel::Constant(IssmDouble* poutput,int constant_enum){/*{{{*/
 
 	_assert_(constant_enum>=0);
@@ -253,6 +246,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::Constant(char** poutput,int constant_enum){{{*/
-void IoModel::Constant(char** poutput,int constant_enum){
+void IoModel::Constant(char** poutput,int constant_enum){/*{{{*/
 
 	_assert_(constant_enum>=0);
@@ -262,6 +254,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::CopyConstantObject{{{*/
-Param* IoModel::CopyConstantObject(int constant_enum){
+Param* IoModel::CopyConstantObject(int constant_enum){/*{{{*/
 
 	_assert_(this->constants);
@@ -274,6 +265,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::Data{{{*/
-IssmDouble* IoModel::Data(int data_enum){
+IssmDouble* IoModel::Data(int data_enum){/*{{{*/
 
 	_assert_(data_enum<MaximumNumberOfDefinitionsEnum);
@@ -283,6 +273,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::StartTrace{{{*/
-void IoModel::StartTrace(void){
+void IoModel::StartTrace(void){/*{{{*/
 
 	bool autodiff = false;
@@ -322,6 +311,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::DeclareIndependents{{{*/
-void IoModel::DeclareIndependents(void){
+void IoModel::DeclareIndependents(void){/*{{{*/
 
 	int  i;
@@ -374,6 +362,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::DeleteData(int num,...){{{*/
-void  IoModel::DeleteData(int num,...){
+void  IoModel::DeleteData(int num,...){/*{{{*/
 
 	va_list ap;
@@ -391,6 +378,5 @@
 	va_end(ap);
 } /*}}}*/
-/*FUNCTION IoModel::DeleteData(IssmDouble* {{{*/
-void  IoModel::DeleteData(IssmDouble* vector, int dataenum){
+void  IoModel::DeleteData(IssmDouble* vector, int dataenum){/*{{{*/
 
 	/*do not erase independent variables for the AD mode computations!: */
@@ -398,6 +384,5 @@
 
 } /*}}}*/
-/*FUNCTION IoModel::DeleteData(char*** pstringarray, int numstrings, int dataenum) {{{*/
-void  IoModel::DeleteData(char*** pstringarray, int numstrings, int dataenum){
+void  IoModel::DeleteData(char*** pstringarray, int numstrings, int dataenum){/*{{{*/
 
 	int i;
@@ -413,6 +398,5 @@
 	*pstringarray=NULL;
 } /*}}}*/
-/*FUNCTION IoModel::FetchConstants{{{*/
-void  IoModel::FetchConstants(void){
+void  IoModel::FetchConstants(void){/*{{{*/
 
 	int my_rank;
@@ -637,6 +621,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchData(bool*         pbool,int data_enum){{{*/
-void  IoModel::FetchData(bool* pboolean,int data_enum){
+void  IoModel::FetchData(bool* pboolean,int data_enum){/*{{{*/
 
 	int my_rank;
@@ -666,6 +649,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchData(int*          pinteger,int data_enum){{{*/
-void  IoModel::FetchData(int* pinteger,int data_enum){
+void  IoModel::FetchData(int* pinteger,int data_enum){/*{{{*/
 
 	int my_rank;
@@ -694,6 +676,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchData(IssmDouble*   pscalar,int data_enum){{{*/
-void  IoModel::FetchData(IssmDouble* pscalar,int data_enum){
+void  IoModel::FetchData(IssmDouble* pscalar,int data_enum){/*{{{*/
 
 	int my_rank;
@@ -722,6 +703,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchData(char**        pstring,int data_enum){{{*/
-void  IoModel::FetchData(char** pstring,int data_enum){
+void  IoModel::FetchData(char** pstring,int data_enum){/*{{{*/
 
 	int my_rank;
@@ -769,6 +749,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchData(int**         pintegerematrix,int* pM,int* pN,int data_enum){{{*/
-void  IoModel::FetchData(int** pmatrix,int* pM,int* pN,int data_enum){
+void  IoModel::FetchData(int** pmatrix,int* pM,int* pN,int data_enum){/*{{{*/
 
 	int my_rank;
@@ -838,6 +817,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchData(IssmDouble**  pIssmDoublematrix,int* pM,int* pN,int data_enum){{{*/
-void  IoModel::FetchData(IssmDouble** pmatrix,int* pM,int* pN,int data_enum){
+void  IoModel::FetchData(IssmDouble** pmatrix,int* pM,int* pN,int data_enum){/*{{{*/
 
 	int my_rank;
@@ -898,6 +876,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchData(char***       pstrings,int* pnumstrings,int data_enum){{{*/
-void  IoModel::FetchData(char*** pstrings,int* pnumstrings,int data_enum){
+void  IoModel::FetchData(char*** pstrings,int* pnumstrings,int data_enum){/*{{{*/
 
 	int my_rank;
@@ -964,6 +941,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchData(IssmDouble*** pmatrices,int** pmdims,int** pndims, int* pM,int data_enum){{{*/
-void  IoModel::FetchData(IssmDouble*** pmatrices,int** pmdims,int** pndims, int* pnumrecords,int data_enum){
+void  IoModel::FetchData(IssmDouble*** pmatrices,int** pmdims,int** pndims, int* pnumrecords,int data_enum){/*{{{*/
 
 	int i;
@@ -1050,6 +1026,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchData(Option**  poption,int data_enum){{{*/
-void  IoModel::FetchData(Option** poption,int index){
+void  IoModel::FetchData(Option** poption,int index){/*{{{*/
 
 	/*output: */
@@ -1096,6 +1071,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchData(int num,...){{{*/
-void  IoModel::FetchData(int num,...){
+void  IoModel::FetchData(int num,...){/*{{{*/
 
 	va_list     ap;
@@ -1138,6 +1112,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchMultipleData(char***       pstrings,int* pnumstrings,int data_enum){{{*/
-void  IoModel::FetchMultipleData(char*** pstrings,int* pnumstrings,int data_enum){
+void  IoModel::FetchMultipleData(char*** pstrings,int* pnumstrings,int data_enum){/*{{{*/
 
 	int  num_instances;
@@ -1203,6 +1176,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchMultipleData(int** pvector, int* pM,int data_enum){{{*/
-void  IoModel::FetchMultipleData(int** pvector, int* pnum_instances,int data_enum){
+void  IoModel::FetchMultipleData(int** pvector, int* pnum_instances,int data_enum){/*{{{*/
 
 	int     num_instances;
@@ -1257,6 +1229,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchMultipleData(IssmDouble*** pmatrices,int** pmdims,int** pndims, int* pM,int data_enum){{{*/
-void  IoModel::FetchMultipleData(IssmDouble*** pmatrices,int** pmdims,int** pndims, int* pnumrecords,int data_enum){
+void  IoModel::FetchMultipleData(IssmDouble*** pmatrices,int** pmdims,int** pndims, int* pnumrecords,int data_enum){/*{{{*/
 
 	int     num_instances;
@@ -1362,6 +1333,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchMultipleData(int*** pmatrices,int** pmdims,int** pndims, int* pM,int data_enum){{{*/
-void  IoModel::FetchMultipleData(int*** pmatrices,int** pmdims,int** pndims, int* pnumrecords,int data_enum){
+void  IoModel::FetchMultipleData(int*** pmatrices,int** pmdims,int** pndims, int* pnumrecords,int data_enum){/*{{{*/
 
 	int     num_instances;
@@ -1469,6 +1439,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchDataToInput(Elements* elements,int vector_enum,IssmDouble default_value){{{*/
-void IoModel::FetchDataToInput(Elements* elements,int vector_enum,IssmDouble default_value){
+void IoModel::FetchDataToInput(Elements* elements,int vector_enum,IssmDouble default_value){/*{{{*/
 
 	/*intermediary: */
@@ -1495,6 +1464,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::FetchDataToInput(Elements* elements,int vector_enum){{{*/
-void IoModel::FetchDataToInput(Elements* elements,int vector_enum){
+void IoModel::FetchDataToInput(Elements* elements,int vector_enum){/*{{{*/
 
 	/*intermediary: */
@@ -1568,6 +1536,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::LastIndex{{{*/
-void IoModel::LastIndex(int *pindex){
+void IoModel::LastIndex(int *pindex){/*{{{*/
 
 	int my_rank;
@@ -1669,6 +1636,5 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::SetFilePointersToData{{{*/
-fpos_t* IoModel::SetFilePointersToData(int** pcodes,int** pvector_types, int* pnum_instances, int data_enum){
+fpos_t* IoModel::SetFilePointersToData(int** pcodes,int** pvector_types, int* pnum_instances, int data_enum){/*{{{*/
 
 	int     found          = 0;
Index: issm/trunk/src/c/classes/Loads/Friction.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Friction.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Friction.cpp	(revision 18301)
@@ -16,6 +16,5 @@
 
 /*Constructors/destructors*/
-/*FUNCTION Friction::Friction() {{{*/
-Friction::Friction(){
+Friction::Friction(){/*{{{*/
 	this->element=NULL;
 	this->dim=0;
@@ -24,6 +23,5 @@
 }
 /*}}}*/
-/*FUNCTION Friction::Friction(Element* element,int dim){{{*/
-Friction::Friction(Element* element_in,int dim_in){
+Friction::Friction(Element* element_in,int dim_in){/*{{{*/
 
 	this->element=element_in;
@@ -32,18 +30,15 @@
 }
 /*}}}*/
-/*FUNCTION Friction::~Friction() {{{*/
-Friction::~Friction(){
+Friction::~Friction(){/*{{{*/
 }
 /*}}}*/
 
 /*methods: */
-/*FUNCTION Friction::Echo {{{*/
-void Friction::Echo(void){
+void Friction::Echo(void){/*{{{*/
 	_printf_("Friction:\n");
 	_printf_("   dim: " << this->dim<< "\n");
 }
 /*}}}*/
-/*FUNCTION Friction::GetAlpha2{{{*/
-void Friction::GetAlpha2(IssmDouble* palpha2, Gauss* gauss){
+void Friction::GetAlpha2(IssmDouble* palpha2, Gauss* gauss){/*{{{*/
 
 	switch(this->law){
@@ -59,6 +54,5 @@
 
 }/*}}}*/
-/*FUNCTION Friction::GetAlpha2{{{*/
-void Friction::GetAlpha2Viscous(IssmDouble* palpha2, Gauss* gauss){
+void Friction::GetAlpha2Viscous(IssmDouble* palpha2, Gauss* gauss){/*{{{*/
 
 	/*This routine calculates the basal friction coefficient 
@@ -120,6 +114,5 @@
 	*palpha2=alpha2;
 }/*}}}*/
-/*FUNCTION Friction::GetAlpha2Weertman{{{*/
-void Friction::GetAlpha2Weertman(IssmDouble* palpha2, Gauss* gauss){
+void Friction::GetAlpha2Weertman(IssmDouble* palpha2, Gauss* gauss){/*{{{*/
 
 	/*This routine calculates the basal friction coefficient alpha2= C^-1/m |v|^(1/m-1) */
@@ -162,6 +155,5 @@
 	*palpha2=alpha2;
 }/*}}}*/
-/*FUNCTION Friction::GetAlphaComplement(IssmDouble* palpha_complement, Gauss* gauss,int vxenum,int vyenum,int vzenum) {{{*/
-void Friction::GetAlphaComplement(IssmDouble* palpha_complement, Gauss* gauss){
+void Friction::GetAlphaComplement(IssmDouble* palpha_complement, Gauss* gauss){/*{{{*/
 
 	/* FrictionGetAlpha2 computes alpha2= drag^2 * Neff ^r * vel ^s, with Neff=rho_ice*g*thickness+rho_ice*g*bed, r=q/p and s=1/p. 
Index: issm/trunk/src/c/classes/Loads/Load.h
===================================================================
--- issm/trunk/src/c/classes/Loads/Load.h	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Load.h	(revision 18301)
@@ -26,4 +26,5 @@
 		virtual       ~Load(){};
 		virtual void  Configure(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters)=0;
+		virtual void  ResetHooks()=0;
 		virtual bool  IsPenalty(void)=0;
 		virtual int   GetNumberOfNodes(void)=0;
Index: issm/trunk/src/c/classes/Loads/Loads.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Loads.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Loads.cpp	(revision 18301)
@@ -23,12 +23,10 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Loads::Loads(){{{*/
-Loads::Loads(){
+Loads::Loads(){/*{{{*/
 	enum_type=LoadsEnum;
 	return;
 }
 /*}}}*/
-/*FUNCTION Loads::~Loads(){{{*/
-Loads::~Loads(){
+Loads::~Loads(){/*{{{*/
 	return;
 }
@@ -36,6 +34,5 @@
 
 /*Numerics:*/
-/*FUNCTION Loads::Configure{{{*/
-void Loads::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
+void Loads::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){/*{{{*/
 
 	vector<Object*>::iterator object;
@@ -51,6 +48,19 @@
 }
 /*}}}*/
-/*FUNCTION Loads::IsPenalty{{{*/
-bool Loads::IsPenalty(int analysis_type){
+void Loads::ResetHooks(){/*{{{*/
+
+	vector<Object*>::iterator object;
+	Load* load=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		load=dynamic_cast<Load*>((*object));
+		load->ResetHooks();
+
+	}
+
+}
+/*}}}*/
+bool Loads::IsPenalty(int analysis_type){/*{{{*/
 
 	int ispenalty=0;
@@ -76,6 +86,5 @@
 }
 /*}}}*/
-/*FUNCTION Loads::MaxNumNodes{{{*/
-int Loads::MaxNumNodes(int analysis_type){
+int Loads::MaxNumNodes(int analysis_type){/*{{{*/
 
 	int max=0;
@@ -100,6 +109,5 @@
 }
 /*}}}*/
-/*FUNCTION Loads::NumberOfLoads(){{{*/
-int Loads::NumberOfLoads(void){
+int Loads::NumberOfLoads(void){/*{{{*/
 
 	int localloads;
@@ -116,6 +124,5 @@
 }
 /*}}}*/
-/*FUNCTION Loads::NumberOfLoads(int analysis){{{*/
-int Loads::NumberOfLoads(int analysis_type){
+int Loads::NumberOfLoads(int analysis_type){/*{{{*/
 
 	int localloads = 0;
@@ -138,12 +145,10 @@
 }
 /*}}}*/
-/*FUNCTION Loads::Size(){{{*/
-int Loads::Size(void){
+int Loads::Size(void){/*{{{*/
 
 	return this->DataSet::Size();
 }
 /*}}}*/
-/*FUNCTION Loads::Size(int analysis){{{*/
-int Loads::Size(int analysis_type){
+int Loads::Size(int analysis_type){/*{{{*/
 
 	int localloads = 0;
@@ -161,6 +166,5 @@
 }
 /*}}}*/
-/*FUNCTION Loads::SetCurrentConfiguration{{{*/
-void Loads::SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
+void Loads::SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){/*{{{*/
 
 	vector<Object*>::iterator object;
Index: issm/trunk/src/c/classes/Loads/Loads.h
===================================================================
--- issm/trunk/src/c/classes/Loads/Loads.h	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Loads.h	(revision 18301)
@@ -24,4 +24,5 @@
 		/*numerics*/
 		void  Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+		void  ResetHooks();
 		bool  IsPenalty(int analysis);
 		int   MaxNumNodes(int analysis);
